## mingw-w64-aws-c-mqtt-0.13.5-1.src.tar.zst

=== tests/CMakeLists.txt ===
include(CTest)
include(AwsTestHarness)
include(AwsLibFuzzer)
enable_testing()

file(GLOB TEST_HDRS "v3/*.h" "v5/*.h" "request-response/*.h")
set(TEST_SRC "v3/*.c" "v5/*.c" "request-response/*.c" "*.c")
file(GLOB TESTS ${TEST_HDRS} ${TEST_SRC})

add_test_case(mqtt_packet_puback)
add_test_case(mqtt_packet_pubrec)
add_test_case(mqtt_packet_pubrel)
add_test_case(mqtt_packet_pubcomp)
add_test_case(mqtt_packet_suback)
add_test_case(mqtt_packet_unsuback)
add_test_case(mqtt_packet_connect)
add_test_case(mqtt_packet_connect_will)
add_test_case(mqtt_packet_connect_empty_payload_will)
add_test_case(mqtt_packet_connect_password)
add_test_case(mqtt_packet_connect_all)
add_test_case(mqtt_packet_connack)
add_test_case(mqtt_packet_publish_qos0_dup)
add_test_case(mqtt_packet_publish_qos2_retain)
add_test_case(mqtt_packet_publish_empty_payload)
add_test_case(mqtt_packet_subscribe)
add_test_case(mqtt_packet_unsubscribe)
add_test_case(mqtt_packet_pingreq)
add_test_case(mqtt_packet_pingresp)
add_test_case(mqtt_packet_disconnect)

add_test_case(mqtt_packet_connack_decode_failure_reserved)
add_test_case(mqtt_packet_ack_decode_failure_reserved)
add_test_case(mqtt_packet_pingresp_decode_failure_reserved)

add_test_case(mqtt_frame_and_decode_publish)
add_test_case(mqtt_frame_and_decode_suback)
add_test_case(mqtt_frame_and_decode_unsuback)
add_test_case(mqtt_frame_and_decode_puback)
add_test_case(mqtt_frame_and_decode_pingresp)
add_test_case(mqtt_frame_and_decode_connack)
add_test_case(mqtt_frame_and_decode_bad_remaining_length)
add_test_case(mqtt_frame_and_decode_unsupported_packet_type)
add_test_case(mqtt_frame_and_decode_bad_flags_for_packet_type)

add_test_case(mqtt_topic_tree_match)
add_test_case(mqtt_topic_tree_unsubscribe)
add_test_case(mqtt_topic_tree_duplicate_transactions)
add_test_case(mqtt_topic_tree_transactions)
add_test_case(mqtt_topic_validation)
add_test_case(mqtt_topic_filter_validation)

add_test_case(mqtt_connect_disconnect)
add_test_case(mqtt_connect_set_will_login)
add_test_case(mqtt_connection_interrupted)
add_test_case(mqtt_connection_any_publish)
add_test_case(mqtt_connection_timeout)
add_test_case(mqtt_connection_connack_timeout)
add_test_case(mqtt_connection_failure_callback)
add_test_case(mqtt_connection_success_callback)
add_test_case(mqtt_connect_subscribe)
add_test_case(mqtt_connect_subscribe_fail_from_broker)
add_test_case(mqtt_connect_subscribe_multi)
add_test_case(mqtt_connect_subscribe_incoming_dup)
add_test_case(mqtt_connect_unsubscribe)
add_test_case(mqtt_connect_resubscribe)
add_test_case(mqtt_connect_publish)
add_test_case(mqtt_connect_publish_payload)
add_test_case(mqtt_connection_offline_publish)
add_test_case(mqtt_connection_disconnect_while_reconnecting)
add_test_case(mqtt_connection_closes_while_making_requests)
add_test_case(mqtt_connection_resend_packets)
# It's too complicate to implement... Let's save it for the future.
# add_test_case(mqtt_connection_not_retry_publish_QoS_0)
add_test_case(mqtt_connection_consistent_retry_policy)
add_test_case(mqtt_connection_not_resend_packets_on_healthy_connection)
add_test_case(mqtt_connection_destory_pending_requests)
add_test_case(mqtt_clean_session_not_retry)
add_test_case(mqtt_clean_session_discard_previous)
add_test_case(mqtt_clean_session_keep_next_session)
add_test_case(mqtt_connection_publish_QoS1_timeout)
add_test_case(mqtt_connection_publish_QoS1_timeout_override)
add_test_case(mqtt_connection_unsubscribe_timeout)
add_test_case(mqtt_connection_unsubscribe_timeout_override)
add_test_case(mqtt_connection_subscribe_single_timeout)
add_test_case(mqtt_connection_subscribe_single_timeout_override)
add_test_case(mqtt_connection_subscribe_multi_timeout)
add_test_case(mqtt_connection_resubscribe_timeout)
add_test_case(mqtt_connection_publish_QoS1_timeout_with_ping)
add_test_case(mqtt_connection_publish_QoS1_timeout_connection_lost_reset_time)
add_test_case(mqtt_connection_ping_norm)
add_test_case(mqtt_connection_ping_no)
add_test_case(mqtt_connection_ping_noack)
add_test_case(mqtt_connection_ping_basic_scenario)
add_test_case(mqtt_connection_ping_double_scenario)
add_test_case(mqtt_connection_close_callback_simple)
add_test_case(mqtt_connection_close_callback_interrupted)
add_test_case(mqtt_connection_close_callback_multi)
add_test_case(mqtt_connection_close_callback_set_failure)
add_test_case(mqtt_connection_close_callback_set_during_connecting)
add_test_case(mqtt_connection_reconnection_backoff_stable)
add_test_case(mqtt_connection_reconnection_backoff_unstable)
add_test_case(mqtt_connection_reconnection_backoff_reset)
add_test_case(mqtt_connection_reconnection_backoff_reset_after_disconnection)

add_test_case(mqtt_validation_failure_publish_qos)
add_test_case(mqtt_validation_failure_invalid_will_qos)
add_test_case(mqtt_validation_failure_subscribe_empty)
add_test_case(mqtt_validation_failure_unsubscribe_null)
add_test_case(mqtt_validation_failure_connect_invalid_client_id_utf8)
add_test_case(mqtt_validation_failure_invalid_will_topic_utf8)
add_test_case(mqtt_validation_failure_invalid_username_utf8)

add_test_case(mqtt_websocket_failed_transform)

# Operation statistics tests
add_test_case(mqtt_operation_statistics_simple_publish)
add_test_case(mqtt_operation_statistics_offline_publish)
add_test_case(mqtt_operation_statistics_disconnect_publish)
add_test_case(mqtt_operation_statistics_reconnect_publish)
add_test_case(mqtt_operation_statistics_simple_subscribe)
add_test_case(mqtt_operation_statistics_simple_unsubscribe)
add_test_case(mqtt_operation_statistics_simple_resubscribe)
add_test_case(mqtt_operation_statistics_simple_callback)

# Connection termination tests
add_test_case(mqtt_connection_termination_callback_simple)

# MQTT5 tests

# topic utilities
add_test_case(mqtt5_topic_skip_rules_prefix)
add_test_case(mqtt5_topic_get_segment_count)
add_test_case(mqtt5_shared_subscription_validation)

# utf8 utility
add_test_case(mqtt_utf8_encoded_string_test)

# topic aliasing
add_test_case(mqtt5_inbound_topic_alias_register_failure)
add_test_case(mqtt5_inbound_topic_alias_resolve_success)
add_test_case(mqtt5_inbound_topic_alias_resolve_failure)
add_test_case(mqtt5_inbound_topic_alias_reset)
add_test_case(mqtt5_outbound_topic_alias_disabled_resolve_success)
add_test_case(mqtt5_outbound_topic_alias_disabled_resolve_failure)
add_test_case(mqtt5_outbound_topic_alias_manual_resolve_failure_zero_alias)
add_test_case(mqtt5_outbound_topic_alias_manual_resolve_failure_too_big_alias)
add_test_case(mqtt5_outbound_topic_alias_manual_resolve_success)
add_test_case(mqtt5_outbound_topic_alias_manual_reset)
add_test_case(mqtt5_outbound_topic_alias_lru_zero_size)

# lru topic sequence tests
# cache size of 2
# a, b, c, refer to distinct topics
# the 'r' suffice refers to expected alias reuse
add_test_case(mqtt5_outbound_topic_alias_lru_a_ar)
add_test_case(mqtt5_outbound_topic_alias_lru_b_a_br)
add_test_case(mqtt5_outbound_topic_alias_lru_a_b_ar_br)
add_test_case(mqtt5_outbound_topic_alias_lru_a_b_c_br_cr_br_cr_a)
add_test_case(mqtt5_outbound_topic_alias_lru_a_b_c_a_cr_b)
add_test_case(mqtt5_outbound_topic_alias_lru_a_b_reset_a_b)

# mqtt operation/storage/view creation/relationship tests
add_test_case(mqtt5_publish_operation_new_set_no_optional)
add_test_case(mqtt5_publish_operation_new_set_all)
add_test_case(mqtt5_publish_operation_new_failure_packet_id)
add_test_case(mqtt5_subscribe_operation_new_set_no_optional)
add_test_case(mqtt5_subscribe_operation_new_set_all)
add_test_case(mqtt5_unsubscribe_operation_new_set_all)
add_test_case(mqtt5_connect_storage_new_set_no_optional)
add_test_case(mqtt5_connect_storage_new_set_all)
add_test_case(mqtt5_connack_storage_new_set_no_optional)
add_test_case(mqtt5_connack_storage_new_set_all)
add_test_case(mqtt5_disconnect_storage_new_set_no_optional)
add_test_case(mqtt5_disconnect_storage_new_set_all)
add_test_case(mqtt5_suback_storage_new_set_no_optional)
add_test_case(mqtt5_suback_storage_new_set_all)
add_test_case(mqtt5_unsuback_storage_new_set_no_optional)
add_test_case(mqtt5_unsuback_storage_new_set_all)
add_test_case(mqtt5_puback_storage_new_set_all)
add_test_case(mqtt5_publish_storage_new_set_all)

# operation/view validation failure tests
add_test_case(mqtt5_operation_disconnect_validation_failure_server_reference)
add_test_case(mqtt5_operation_disconnect_validation_failure_bad_reason_code)
add_test_case(mqtt5_operation_disconnect_validation_failure_reason_string_too_long)
add_test_case(mqtt5_operation_disconnect_validation_failure_reason_string_invalid_utf8)
add_test_case(mqtt5_operation_disconnect_validation_failure_user_properties_name_too_long)
add_test_case(mqtt5_operation_disconnect_validation_failure_user_properties_name_invalid_utf8)
add_test_case(mqtt5_operation_disconnect_validation_failure_user_properties_value_too_long)
add_test_case(mqtt5_operation_disconnect_validation_failure_user_properties_value_invalid_utf8)
add_test_case(mqtt5_operation_disconnect_validation_failure_user_properties_too_many)
add_test_case(mqtt5_operation_connect_validation_failure_client_id_too_long)
add_test_case(mqtt5_operation_connect_validation_failure_client_id_invalid_utf8)
add_test_case(mqtt5_operation_connect_validation_failure_username_too_long)
add_test_case(mqtt5_operation_connect_validation_failure_username_invalid_utf8)
add_test_case(mqtt5_operation_connect_validation_failure_password_too_long)
add_test_case(mqtt5_operation_connect_validation_failure_receive_maximum_zero)
add_test_case(mqtt5_operation_connect_validation_failure_maximum_packet_size_zero)
add_test_case(mqtt5_operation_connect_validation_failure_will_invalid)
add_test_case(mqtt5_operation_connect_validation_failure_will_payload_too_long)
add_test_case(mqtt5_operation_connect_validation_failure_auth_method_unsupported)
add_test_case(mqtt5_operation_connect_validation_failure_auth_data_unsupported)
add_test_case(mqtt5_operation_connect_validation_failure_request_problem_information_invalid)
add_test_case(mqtt5_operation_connect_validation_failure_request_response_information_invalid)
add_test_case(mqtt5_operation_connect_validation_failure_user_properties_name_too_long)
add_test_case(mqtt5_operation_connect_validation_failure_user_properties_name_invalid_utf8)
add_test_case(mqtt5_operation_connect_validation_failure_user_properties_value_too_long)
add_test_case(mqtt5_operation_connect_validation_failure_user_properties_value_invalid_utf8)
add_test_case(mqtt5_operation_connect_validation_failure_user_properties_too_many)
add_test_case(mqtt5_operation_subscribe_validation_failure_no_subscriptions)
add_test_case(mqtt5_operation_subscribe_validation_failure_too_many_subscriptions)
add_test_case(mqtt5_operation_subscribe_validation_failure_invalid_subscription_identifier)
add_test_case(mqtt5_operation_subscribe_validation_failure_invalid_topic_filter)
add_test_case(mqtt5_operation_subscribe_validation_failure_invalid_utf8_topic_filter)
add_test_case(mqtt5_operation_subscribe_validation_failure_invalid_qos)
add_test_case(mqtt5_operation_subscribe_validation_failure_invalid_retain_type)
add_test_case(mqtt5_operation_subscribe_validation_failure_invalid_no_local)
add_test_case(mqtt5_operation_subscribe_validation_failure_user_properties_name_too_long)
add_test_case(mqtt5_operation_subscribe_validation_failure_user_properties_name_invalid_utf8)
add_test_case(mqtt5_operation_subscribe_validation_failure_user_properties_value_too_long)
add_test_case(mqtt5_operation_subscribe_validation_failure_user_properties_value_invalid_utf8)
add_test_case(mqtt5_operation_subscribe_validation_failure_user_properties_too_many)
add_test_case(mqtt5_operation_unsubscribe_validation_failure_no_topic_filters)
add_test_case(mqtt5_operation_unsubscribe_validation_failure_too_many_topic_filters)
add_test_case(mqtt5_operation_unsubscribe_validation_failure_invalid_topic_filter)
add_test_case(mqtt5_operation_unsubscribe_validation_failure_invalid_utf8_topic_filter)
add_test_case(mqtt5_operation_unsubscribe_validation_failure_user_properties_name_too_long)
